Title   Create PCI_Bus_# entries for nonzero # - code

;

; bx=bus/device/function of bridge
a_proc                  create_additional_bridge_and_pcibus
                        push es
                        pushad

                          call get_bustype

                          mov pcibridge_hDevice,-1
                          mov pcibus_hAdapter,-1

                          ; 1) create device 'PCI_Bridge_#'
                          ; parent adapter is 'PCI_Bus_#'
                          ; can use classtable names for device description

                          ; Device Number=number of the first BUS created=secondary bus number
                          mov di,019h
                          call Read_PCI_Byte
                          movzx ax,cl
                          mov new_pci_bridge_Adj_DeviceNum,ax

                          Set_PCI_DevFunc new_pci_bridge_Adj_PCIDevFunc,bx


                          push DWord Ptr 0                              ; > @resource list (added later)

                          call search_create_additional_pcibus__primary ; \ get handle of PCI_Bus_# where #=bh
                          push eax                                      ; / hParentDevice = current bus handle

                          push ds                                       ; \ @DeviceStruct
                          push Offset new_pci_bridge_DeviceStruct       ; /

                          push ds                                       ; \ @hDevice
                          push Offset pcibridge_hDevice                 ; /

                          push hDriver                                  ; > hDriver
                          call set_pcibridge_adapternumber_append
                          call set_pcibridge_classdescription
                          CallRM RMCreateDevice
                          add sp,4+4+4+4+4
                          test ax,ax
                          jnz @@exit


                          ; 2) create adapter 'PCI_Bus_#'
                          ; parent device is 'PCI_Bridge_#' from step 1)

                          call create_bus_behind_bridge

  @@exit:

                        popad
                        pop es
                        ret
a_endp                  create_additional_bridge_and_pcibus

;

a_proc                  create_bus_behind_bridge
                        push es
                        pushad

                          ; Adapter Number=number of the BUS created=secondary bus number
                          mov ax,new_pci_bridge_Adj_DeviceNum
                          mov new_pci_bus_Adj_AdapNum,ax

                          mov di,ax
                          mov ax,AS_HOSTBUS_PLANAR
                          mov bx,AS_BUSWIDTH_UNKNOWN
                          ; directly connected to CPU?
                          add di,di
                          mov dx,pci_busnumber_from[di]
                          cmp dx,0ffffh
                          je @@connected_to_cpu

                          ; connected via a PCI bridge
                          mov ax,AS_HOSTBUS_PCI
                          movzx di,bh                           ; primary bus type..
                          movzx di,bustypes[di]
                          mov ax,bustype_with[di]
  @@connected_to_cpu:
                          mov new_pci_bus_parent_with,ax
                          mov new_pci_bus_parent_hostbus,bx

                          push DWord Ptr 0                      ; > @resource list (none)

                          push pcibridge_hDevice                ; / hParentDevice = 'PCI_Bridge_#'

                          push ds                               ; \ @AdapterStruct
                          push Offset new_pci_bus_AdapterStruct ; /

                          push ds                               ; \ @hAdapter
                          push Offset pcibus_hAdapter           ; /

                          push hDriver                          ; > hDriver

                          mov di,Offset new_pci_bus_append      ; fill in bus number
                          movzx eax,new_pci_bus_Adj_AdapNum     ; could use '#' for automatic fill-in
                          call append_dec_number_autolen        ; but that would cause unneeded blanks
                          mov Byte Ptr es:[di],0

                          call set_pcibus_typedescription

                          CallRM RMCreateAdapter
                          add sp,4+4+4+4+4

                        popad
                        pop es
                        ret
a_endp                  create_bus_behind_bridge

;
; return PCI bus adapter handle. If it does not exist, create a dummy device+new adapter,
; directly connected to the first CPU.
; reason: we process bridges linary, if should have created such an device if it exist,
; but on some hardware there are two PCI Busses connected to the CPU. We can
; not create that (CPU_0 is an adapter)
;
; bh=bus number
;
; -> eax
a_proc                  search_create_additional_pcibus__primary
                        call search_pcibus_handle
                        test eax,eax
                        jnz @@exit

                        ; 1) create device 'PCI_Bridge_#'
                        ; parent adapter is 'CPU_0'
                        ; very similar to abovem but this bridge has
                        ; no PCI bus/device/function address

                        push es
                        pushad

                        push [new_pci_bridge_AdjunctList].pNextAdj
                        push new_pci_bridge_Adj_DeviceNum
                        push new_pci_bus_Adj_AdapNum

                          mov [new_pci_bridge_AdjunctList].pNextAdj,0
                          movzx ax,bh
                          mov new_pci_bridge_Adj_DeviceNum,ax


                          push DWord Ptr 0                              ; > @resource list - none

                          call search_cpu0_handle                       ; \ hParentAdapter
                          push eax                                      ; /  = directly connected to CPU

                          push ds                                       ; \ @DeviceStruct
                          push Offset new_pci_bridge_DeviceStruct       ; /

                          push ds                                       ; \ @hDevice
                          push Offset pcibridge_hDevice                 ; /

                          push hDriver                                  ; > hDriver
                          call set_pcibridge_adapternumber_append
                         ; no bridge class code known ...
                          CallRM RMCreateDevice
                          add sp,4+4+4+4+4
                          test ax,ax
                          jnz @@fail1

                          ; 2) create adapter 'PCI_Bus_#'
                          ; parent device is 'PCI_Bridge_#' from step 1)

                          call create_bus_behind_bridge
  @@fail1:
                        pop new_pci_bus_Adj_AdapNum
                        pop new_pci_bridge_Adj_DeviceNum
                        pop [new_pci_bridge_AdjunctList].pNextAdj

                        popad
                        pop es

                        ; ask again. this time should have a good handle
                        call search_pcibus_handle

  @@exit:
                        ret
a_endp                  search_create_additional_pcibus__primary

;
; bh=bus number
; ->eax
; returns eax=0 on error

a_proc                  search_pcibus_handle
                        push es
                        pushad

                          push ds
                          pop es
                          mov di,Offset search_pcibus_num
                          movzx eax,bh
                          call append_dec_number_autolen
                          mov Word Ptr [di],'*'+(0 shl 8)

                          mov s_cHandles, 0
                          mov s_hAdapter1, -1

                          push ds                       ; \ HandleList
                          push Offset search_handlelist ; /
                          push ds                       ; \ Search Key
                          push Offset search_pcibus_x   ; /
                          push HANDLE_PHYS_TREE         ; > Physical Device Nodes
                          CallRM RMKeyToHandleList
                          add sp,4+4+4
                          test ax,ax

                          if_nz <mov s_hAdapter1,0>
                          cmp s_cHandles,1
                          if_b <mov s_hAdapter1,0>

                        popad
                        pop es

                        mov eax,s_hAdapter1
                        ret
a_endp                  search_pcibus_handle
;
; returns handle for 'CPU_0 686' or similar
; returns eax=0 on error
a_proc                  search_cpu0_handle
                        push es
                        pushad

                          mov s_cHandles, 0
                          mov s_hAdapter1, -1

                          push ds                       ; \ HandleList
                          push Offset search_handlelist ; /
                          push ds                       ; \ Search Key
                          push Offset search_cpu0       ; /
                          push HANDLE_PHYS_TREE         ; > Physical Device Nodes
                          CallRM RMKeyToHandleList
                          add sp,4+4+4
                          test ax,ax
                          if_nz <mov s_hAdapter1,0>
                          cmp s_cHandles,1
                          if_b <mov s_hAdapter1,0>

                        popad
                        pop es

                        mov eax,s_hAdapter1
                        ret
a_endp                  search_cpu0_handle
;
; bx=bus/device/function of bridge
a_proc                  get_bustype
                        push do_all_pci_functions_proc
                        pushad

                          ; *** secondary bus (behind bridge) ***

                          mov di,019h                   ; secondary bus number
                          call Read_PCI_Byte
                          movzx si,cl
                          cmp bustypes[si],bustype_pci
                          jne @@exit

                          cmp current_header.hdr_type,2 ; pci->cardbus header?
                          jne @@not_cardbus_bridge

                          mov bustypes[si],bustype_cardbus
                          jmp @@exit

  @@not_cardbus_bridge:
                          ; type 1 (PCI->PCI)
                          ; can be AGP/PCI-X/...
                          mov dl,007h                   ; pci-x msi
                          call SearchCapability
                          test di,di
                          jz @@not_pci_x_bridge

                          mov bustypes[si],bustype_pci_x
                          jmp @@exit
  @@not_pci_x_bridge:
                          ; look for AGP: VGA Mapping flag
                          mov di,0003eh
                          call Read_PCI_Byte
                          test cl,008h
                          jz @@not_agp

                          mov bustypes[si],bustype_agp
                          jmp @@exit
  @@not_agp:

                          ; for PCI Express, i need to look at the devices behind
                          ; the bridge...
                          push bx

                            mov do_all_pci_functions_proc,Offset look_if_device_is_on_pci_express
                            mov bx,si

                            mov cx,32
  @@next_device:
                            call do_all_pci_functions
                            cmp bustypes[si],bustype_pci        ; break, when the first pci express device was found
                            jne @@exit
                            add bx,8
                            loop @@next_device

                          pop bx
  @@exit:
                        popad
                        pop do_all_pci_functions_proc
                        ret
a_endp                  get_bustype
;
a_proc                  look_if_device_is_on_pci_express
                        pushad

                          mov dl,010h                   ; PCI Express
                          call SearchCapability
                          test di,di
                          jz @@exit

                          movzx si,bh
                          mov bustypes[si],bustype_pci_express
  @@exit:
                        popad
                        ret
a_endp                  look_if_device_is_on_pci_express
;
; bx=bus/device/function of bridge
a_proc                  set_pcibridge_classdescription
                        push es
                        pushad

                          mov di,Offset new_pci_bridge_descriptionname_append
                          push ds
                          pop es
                          call StrEnd

                          push di
                            mov di,008h         ; revision/classcode
                            call Read_PCI_DWord
                          pop di
                          rol ecx,8
                          cmp cl,6              ; bridge
                          jne @@exit
                          rol ecx,16            ; ch=subclass cl=programming interface
                          mov si,Offset pci_class_array_begin
  @@loop:
                          cmp [si].class_,6
                          jne @@next
                          cmp [si].subclass,ch
                          jne @@next
                          cmp [si].progif,cl
                          jne @@next

                          mov si,[si].cname     ; copy string like 'PCI to PCI'
                          cld
                          mov al,' '
                          stosb
  @@copy:
                          lodsb
                          stosb
                          cmp al,0
                          jne @@copy
                          jmp @@exit

  @@next:
                          add si,Size pci_record
                          cmp si,Offset pci_class_array_end
                          jne @@loop
  @@exit:

                        popad
                        pop es
                        ret
a_endp                  set_pcibridge_classdescription
;
; new_pci_bus_Adj_AdapNum=bus number
a_proc                  set_pcibus_typedescription
                        push es
                        pushad

                          mov di,Offset new_pci_bus_append
                          push ds
                          pop es
                          call StrEnd

                          mov si,new_pci_bus_Adj_AdapNum
                          movzx si,bustypes[si]
                          mov si,bustype_names[si]      ; copy description like 'PCI Express'
                          cld
                          mov al,' '
                          stosb
  @@copy:
                          lodsb
                          stosb
                          cmp al,0
                          jne @@copy
                        popad
                        pop es
                        ret
a_endp                  set_pcibus_typedescription
;
a_proc                  set_pcibridge_adapternumber_append
                        push es
                        pushad
                          mov di,Offset new_pci_bridge_descriptionname_append
                          push ds
                          pop es
                          movzx eax,new_pci_bridge_Adj_DeviceNum
                          call append_dec_number_autolen
                          mov Byte Ptr es:[di],0
                        popad
                        pop es
                        ret
a_endp                  set_pcibridge_adapternumber_append
;
