Title   Create PCI_Bus_# entries for nonzero # - data

;

bustype_pci             equ 0*2
bustype_cardbus         equ 1*2
bustype_agp             equ 2*2
bustype_pci_express     equ 3*2
bustype_pci_x           equ 4*2

bustype_names           dw Offset name_bustype_pci
                        dw Offset name_bustype_cardbus
                        dw Offset name_bustype_agp
                        dw Offset name_bustype_pci_express
                        dw Offset name_bustype_pci_x

bustype_with            dw AS_BUSWIDTH_UNKNOWN  ; PCI          unknown if 32 or 64 bit
                        dw AS_BUSWIDTH_32BIT    ; CardBus
                        dw AS_BUSWIDTH_UNKNOWN  ; AGP          some chips can support 64 bit addresses
                        dw AS_BUSWIDTH_64BIT    ; PCI Express  guess based on vague marketing impression
                        dw AS_BUSWIDTH_64BIT    ; PCI-X        guess based on vague marketing impression

name_bustype_pci        db 0
name_bustype_cardbus    db 'CardBus',0
name_bustype_agp        db 'AGP',0
name_bustype_pci_express db 'PCI Express',0
name_bustype_pci_x      db 'PCI-X',0


bustypes                db 0100h dup (bustype_pci)

                        Public bustype_names,bustypes

;
; bridges=devices...

pcibridge_hDevice       dd -1

new_pci_bridge_descriptionname db 'PCI_Bridge_'
  new_pci_bridge_descriptionname_append db 64 dup (0)

new_pci_bridge_DeviceStruct label byte
                        dd new_pci_bridge_descriptionname       ; DevDescriptName
                        dw 0                                    ; DevFlags
                        dw DS_TYPE_SLOT                         ; DevType - maybe DS_TYPE_UNKNOWN or DS_TYPE_PLANAR_CHIPSET
                        dd new_pci_bridge_AdjunctList           ; pAdjunctList

new_pci_bridge_AdjunctList label byte
  pNextAdj_to_PCIDevFunc dd new_pci_bridge_AdjunctList2         ; pNextAdj
                        dw 4+2+2+2                              ; AdjLenght
                        dw ADJ_DEVICE_NUMBER                    ; AdjType
  new_pci_bridge_Adj_DeviceNum dw ?                             ; Device_Number

new_pci_bridge_AdjunctList2 label byte
                        dd 0                                    ; pNextAdj
                        dw 4+2+2+2                              ; AdjLenght
                        dw ADJ_PCI_DEVFUNC                      ; AdjType
  new_pci_bridge_Adj_PCIDevFunc dw ?                            ; PCI_DevFunc

                        Public pcibridge_hDevice,new_pci_bridge_descriptionname,new_pci_bridge_descriptionname_append
                        Public new_pci_bridge_DeviceStruct,new_pci_bridge_AdjunctList,pNextAdj_to_PCIDevFunc,
                        Public new_pci_bridge_Adj_DeviceNum,new_pci_bridge_AdjunctList2,new_pci_bridge_Adj_PCIDevFunc

;
; busses=adapters..

pcibus_hAdapter         dd -1

new_pci_bus_descriptionname db 'PCI_Bus_'
  new_pci_bus_append    db 64 dup (0)

new_pci_bus_AdapterStruct label byte
                        dd new_pci_bus_descriptionname          ; AdaptDescriptName
                        dw 0                                    ; AdaptFlags
                        dw AS_BASE_BRIDGE                       ; BaseType - AS_BASE_PERIPH?
                        dw AS_SUB_OTHER                         ; SubType
                        dw AS_INTF_GENERIC                      ; InterfaceType
  new_pci_bus_parent_hostbus    dw AS_HOSTBUS_PCI               ; HostBusType
  new_pci_bus_parent_with       dw AS_BUSWIDTH_UNKNOWN          ; HostBusWidth: 32 or 64?
                        dd new_pci_bus_AdjunctList              ; pAdjunctList
                        dd 0                                    ; Reserved

new_pci_bus_AdjunctList label byte
                        dd 0                                    ; pNextAdj
                        dw 4+2+2+2                              ; AdjLenght
                        dw ADJ_ADAPTER_NUMBER                   ; AdjType
  new_pci_bus_Adj_AdapNum dw ?                                  ; Adapter_Number

                        Public pcibus_hAdapter,new_pci_bus_parent_hostbus,new_pci_bus_parent_with,
                        Public new_pci_bus_descriptionname,new_pci_bus_append,
                        Public new_pci_bus_AdapterStruct,new_pci_bus_AdjunctList,new_pci_bus_Adj_AdapNum

;
search_pcibus_x         db 'PCI_Bus_?',0,0,0
search_pcibus_num       equ $-4

search_cpu0             db 'CPU_0 *',0

search_handlelist       label byte
                        dw 1                            ; cMaxHandles
  s_cHandles            dw 0                            ; cHandles
  s_hAdapter1           dd -1                           ; first handle

                        Public search_pcibus_x,search_pcibus_num,search_cpu0,search_handlelist,s_cHandles,s_hAdapter1

;

