program generate_classcode_inc_from_classcode_pas;

uses
  Strings,
  VpUtils;

{$I classes.pas}

(* maximum length of an device/adapter/.. description string is 128 *)
(* example: 'Detected Hardware Function: PCI Device 03-00-00 Display: VGA'         *)
(*        = 'Detected Hardware Function: PCI Device 03-00-00 '+'Display+': '+'VGA' *)
(* but RMView seems only reserve 80 bytes for                       *)
(* 'Detected Hardware Function: PCI Device XX-XX-XX %s ',10,13,10,0 *)
(* ->    27>=Length(pci_class_names)+': '+Length(class_)         *)
(*    or 27>=                            +Length(class_)         *)
const
  maxclasscodechars     =80-Length('Detected Hardware Function: PCI Device XX-XX-XX  '#10#13#10#0);

function restrict_description_length(const p:pChar;const classc:byte):string;
  var
    l           :word;
    s           :string;
  begin
    s:=StrPas(p);
    l:=Length(s);
    if StrLen(pci_class_names[classc])+Length(': ')+l>maxclasscodechars then
      begin
        if l>maxclasscodechars then
          begin
            WriteLn('Description "',s,'" is too long! (+',l-maxclasscodechars,')');
            ReadLn;
          end;
        restrict_description_length:='1,"'+s+'"';
      end
    else
      restrict_description_length:='  "'+s+'"';
  end;

var
  i                     :word;

begin
  WriteLn('title class code table -- automatically generated by genclass');
  WriteLn('pci_class_names_begin:');
  for i:=Low(pci_class_names) to High(pci_class_names) do
    WriteLn(' dw Offset pci_class_name_'+Int2Hex(i,2));
  WriteLn('pci_class_names_end:');
  for i:=Low(pci_class_names) to High(pci_class_names) do
    WriteLn('pci_class_name_'+Int2Hex(i,2)+'  db '{,StrLen(pci_class_names[i]):3,','},'"',pci_class_names[i],'"',',0');
  WriteLn('pci_class_name_low  equ ',Low (pci_class_names));
  WriteLn('pci_class_name_high equ ',High(pci_class_names));


  WriteLn('pci_record   Struc');
  WriteLn('  class_     db ?');
  WriteLn('  subclass   db ?');
  WriteLn('  progif     db ?');
  WriteLn('  cname      dw ?');
  WriteLn('pci_record   EndS');


  WriteLn('pci_class_array_begin:');
  for i:=Low(pci_class_array) to High(pci_class_array) do
    with pci_class_array[i] do
      WriteLn(' pci_record <0'+Int2Hex(class_,2)+'h,0'+Int2Hex(subclass,2)+'h,0'+Int2Hex(progif,2)
        +'h,Offset pci_class_array_'+Int2Hex(class_,2)+Int2Hex(subclass,2)+Int2Hex(progif,2)+'>');
  WriteLn('pci_class_array_end:');
  for i:=Low(pci_class_array) to High(pci_class_array) do
    with pci_class_array[i] do
      WriteLn('pci_class_array_'+Int2Hex(class_,2)+Int2Hex(subclass,2)+Int2Hex(progif,2)+'  db ',restrict_description_length(cname,class_),',0');
end.
